/**
 * ibm-orchestrator-api
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/* tslint:disable:no-unused-variable member-ordering */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { HttpClient, HttpHeaders, HttpParams,
         HttpResponse, HttpEvent, HttpParameterCodec }       from '@angular/common/http';
import { CustomHttpParameterCodec }                          from '../encoder';
import { Observable }                                        from 'rxjs';

import { TestSuite } from '../model/testSuite';

import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';


@Injectable({
  providedIn: 'root'
})
export class TestExecutionControllerService {

    protected basePath = 'http://ibm-orchestrator-api.mybluemix.net';
    public defaultHeaders = new HttpHeaders();
    public configuration = new Configuration();
    public encoder: HttpParameterCodec;

    constructor(protected httpClient: HttpClient, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {

        if (configuration) {
            this.configuration = configuration;
            this.configuration.basePath = configuration.basePath || basePath || this.basePath;

        } else {
            this.configuration.basePath = basePath || this.basePath;
        }
        this.encoder = this.configuration.encoder || new CustomHttpParameterCodec();
    }



    /**
     * @param testSuiteId 
     * @param workspaceId 
     * @param scenarioIndex 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public testExecutionControllerRunTestScenario(testSuiteId: string, workspaceId: string, scenarioIndex: string, observe?: 'body', reportProgress?: boolean): Observable<TestSuite>;
    public testExecutionControllerRunTestScenario(testSuiteId: string, workspaceId: string, scenarioIndex: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<TestSuite>>;
    public testExecutionControllerRunTestScenario(testSuiteId: string, workspaceId: string, scenarioIndex: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<TestSuite>>;
    public testExecutionControllerRunTestScenario(testSuiteId: string, workspaceId: string, scenarioIndex: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (testSuiteId === null || testSuiteId === undefined) {
            throw new Error('Required parameter testSuiteId was null or undefined when calling testExecutionControllerRunTestScenario.');
        }
        if (workspaceId === null || workspaceId === undefined) {
            throw new Error('Required parameter workspaceId was null or undefined when calling testExecutionControllerRunTestScenario.');
        }
        if (scenarioIndex === null || scenarioIndex === undefined) {
            throw new Error('Required parameter scenarioIndex was null or undefined when calling testExecutionControllerRunTestScenario.');
        }

        let headers = this.defaultHeaders;

        // authentication (APIKeyHeader) required
        if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
            headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
        }

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }


        return this.httpClient.post<TestSuite>(`${this.configuration.basePath}/test-execution/${encodeURIComponent(String(testSuiteId))}/workspace/${encodeURIComponent(String(workspaceId))}/scenario/${encodeURIComponent(String(scenarioIndex))}`,
            null,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

    /**
     * @param testSuiteId 
     * @param workspaceId 
     * @param observe set whether or not to return the data Observable as the body, response or events. defaults to returning the body.
     * @param reportProgress flag to report request and response progress.
     */
    public testExecutionControllerRunTestSuite(testSuiteId: string, workspaceId: string, observe?: 'body', reportProgress?: boolean): Observable<TestSuite>;
    public testExecutionControllerRunTestSuite(testSuiteId: string, workspaceId: string, observe?: 'response', reportProgress?: boolean): Observable<HttpResponse<TestSuite>>;
    public testExecutionControllerRunTestSuite(testSuiteId: string, workspaceId: string, observe?: 'events', reportProgress?: boolean): Observable<HttpEvent<TestSuite>>;
    public testExecutionControllerRunTestSuite(testSuiteId: string, workspaceId: string, observe: any = 'body', reportProgress: boolean = false ): Observable<any> {
        if (testSuiteId === null || testSuiteId === undefined) {
            throw new Error('Required parameter testSuiteId was null or undefined when calling testExecutionControllerRunTestSuite.');
        }
        if (workspaceId === null || workspaceId === undefined) {
            throw new Error('Required parameter workspaceId was null or undefined when calling testExecutionControllerRunTestSuite.');
        }

        let headers = this.defaultHeaders;

        // authentication (APIKeyHeader) required
        if (this.configuration.apiKeys && this.configuration.apiKeys["Authorization"]) {
            headers = headers.set('Authorization', this.configuration.apiKeys["Authorization"]);
        }

        // to determine the Accept header
        const httpHeaderAccepts: string[] = [
            'application/json'
        ];
        const httpHeaderAcceptSelected: string | undefined = this.configuration.selectHeaderAccept(httpHeaderAccepts);
        if (httpHeaderAcceptSelected !== undefined) {
            headers = headers.set('Accept', httpHeaderAcceptSelected);
        }


        return this.httpClient.post<TestSuite>(`${this.configuration.basePath}/test-execution/${encodeURIComponent(String(testSuiteId))}/workspace/${encodeURIComponent(String(workspaceId))}`,
            null,
            {
                withCredentials: this.configuration.withCredentials,
                headers: headers,
                observe: observe,
                reportProgress: reportProgress
            }
        );
    }

}
